import os

from attacks import Attack
from consts import *
from utils import create_menu, get_script_dir, print_msg, run_script

script_dir = get_script_dir(__file__)


class BruteForceLocal(Attack):
    def name(self):
        return "brute-force (local)"

    def deps(self):
        return_code = run_script(f"bash {script_dir}/depends.sh")
        if return_code == 0:
            return GRE
        return RED

    def run(self):
        wordlists_path = f"{SCRDIR}/wordlists"
        wordlists = os.listdir(path=wordlists_path)
        hash_types = ["md5", "sha2-256", "bcrypt"]
        pass_hash = input(f"{YEL}password hash:{NOC} ")
        choice = create_menu("hashing algorithm", hash_types)
        if not choice:
            return
        for file in wordlists:
            print(f"{YEL}trying {file}{NOC}")
            return_code = run_script(
                f"bash {script_dir}/run.sh {script_dir} {pass_hash} {hash_types[choice]} {wordlists_path}/{file}"
            )
            if return_code == 0:
                print_msg(f"{YEL}found password{NOC}")
                return
        print_msg(f"{YEL}hashcat finished{NOC}")
