{
  description = "a dev env for the attacker machine";

  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixos-unstable";
  };

  outputs = {nixpkgs, ...}: let
    system = "x86_64-linux";
    pkgs = nixpkgs.legacyPackages.${system};
  in {
    devShells."${system}".default = pkgs.mkShell {
      nativeBuildInputs = with pkgs; [
        python311
        python311Packages.pip
        pipenv
        openssl
      ];
      shellHook = ''
        echo "python: $(python --version)"
        echo "pip: $(pip --version)"
        echo "pipenv: $(pipenv --version)"
      '';
    };
  };
}
