import subprocess
from os import path
from typing import Any

from consts import *


def get_script_dir(file: str):
    return path.dirname(path.abspath(file))


def run_script(script: str):
    result = subprocess.run(args=script.split(" "))
    return result.returncode


def print_msg(message: str):
    input(f"\n{message}\n{YEL}(press enter to continue){NOC}")


def create_menu(title: str, menu_items: list[Any]):
    while True:
        try:
            print(f"\n{YEL} {title}:")
            for i, item in enumerate(menu_items):
                print(f"\t{YEL}|-{i}:{NOC} {item}")
            choice = int(input(f"{YEL}\t|\n\t|-->{NOC} "))
            assert choice < len(menu_items)
            return choice
        except (ValueError, AssertionError):
            print_msg(f"\n{RED}invalid choice{NOC}")
        except KeyboardInterrupt:
            return
        except:
            print_msg(MISSINGDEPS)
